/*
 * (C) Copyright 2000
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <s3c2410.h>
#include <exports.h>
//#include <stdio.h>

#define U32 unsigned int
#define U16 unsigned short int
#define U8 unsigned char
unsigned int hextou(char *s);

int ide_strobe (int argc, char *argv[])
{
	int i;
        U16 temp;
        
        S3C24X0_GPIO * const gpio = S3C24X0_GetBase_GPIO();
        unsigned int addr;

	/* Print the ABI version */
	app_startup(argv);
	printf ("Example expects ABI version %d\n", XF_VERSION);
	printf ("Actual U-Boot ABI version %d\n", (int)get_version());
        gpio->GPBCON=(gpio->GPBCON&~(0x3<<2))|(1<<2);
        gpio->GPBDAT=(gpio->GPBDAT|(0x1<<1));   // On
	printf ("Ide_Strobe \n");

        if(argc < 2)
        {
	   printf("You must list an address!\n");
           return (1);
        }
//        sscanf(argv[argc-1],"%x",&addr);
        addr = hextou(argv[argc-1]);
	printf ("Reading address 0x%x\n",addr);
	printf ("Hit any key to exit ... ");
        i = 0;
	while (!tstc())
        {
           temp = *(volatile U16*)addr;
           if(i > 100000)
           {
             gpio->GPBDAT^=(1<<5);
             i=0;
           }
           i++;
        }
	/* consume input */
	(void) getc();

	printf ("\n\n");
	return (0);
}
unsigned int hextou(char *s)
{
  char *ptr;
  int i,len;
  unsigned int u = 0;
  ptr = s;
  len = 0;
  i = 0;
  while((*ptr != '\0')&&(i<20))
  {
     printf("%c",*ptr);
     ptr++;
     len++;
     i++;
  }
  printf("\n");
  printf("len = %d \n",len);
  ptr--;
  i = 0;
  while((*ptr != 'x')&&(i < len))
  {
    printf("%c",*ptr);
    u += (*ptr - '0')<<4*i;
    i++;
    ptr--;
  }
  printf("\n");
  return u;
}
